Attribute VB_Name = "Module1"
'
'Copyright (C) 2003-2006 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

Option Explicit
Public Declare Function getConfigParameter Lib "mainclientDll.dll" (ByVal name As String, ByVal value As String) As Long
Public Declare Function setConfigParameters Lib "mainclientDll.dll" (ByVal userName As String, ByVal password As String, ByVal syncURL As String, ByVal serverName As String, ByVal errVal As String) As Long
Public Declare Function getSourceParameter Lib "mainclientDll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal value As String) As Long
Public Declare Function setSourceParameters Lib "mainclientDll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal value As String, ByVal errVal As String) As Long
Public Declare Function getClientConfiguration Lib "mainclientDll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String) As Long
Public Declare Function setClientConfiguration Lib "mainclientDll.dll" (ByVal sourceName As String, ByVal propertyName As String, ByVal propertyValue As String, ByVal errVal As String) As Long

Public Declare Function synchronization Lib "mainclientDll.dll" (ByVal errVal As String, ByVal path As String) As Long
Public Declare Function TerminateProcess Lib "Coredll" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

Public Declare Function CreateProcess Lib "coredll.DLL" _
    Alias "CreateProcessW" _
    (ByVal lpApplicationName As String, _
    ByVal lpCommandLine As String, _
    ByVal lpProcessAttributes As Long, _
    ByVal lpThreadAttributes As Long, _
    ByVal bInheritHandles As Long, _
    ByVal dwCreationFlags As Long, _
    ByVal lpEnvironment As Long, _
    ByVal lpCurrentDirectory As Long, _
    ByVal lpStartupInfo As Long, _
    ByVal lpProcessInformation As String) As Long




Dim path As String



Public Function AppPath() As String
'Calculate the complete path of the application
    
    
    Dim path
    path = App.path
    If path = "\" Then
        AppPath = "\"
    Else
        AppPath = path & "\"
    End If
    
End Function



Public Function MemStringToLong(StringIn As String) As Long
       On Error Resume Next
       Dim hWorkVal As String
       '
       ' Convert the String back to Long Integer.
       ' Converting back to Big Endian format.

      Dim I As Long
      For I = 4 To 1 Step -1
       hWorkVal = hWorkVal & Hex(AscB(MidB(StringIn, I, 1)))
      Next I
       '
       ' Return Long Integer value.
       MemStringToLong = CLng("&H" & hWorkVal)
   End Function

Public Sub getPROCESS_INFORMATION(ByVal sPROCESS_INFORMATION As String, _
                   ByRef hProcess As Long, ByRef hThread As Long, _
                   ByRef dwProcessId As Long, ByRef dwThreadId As Long)

    '
    ' Convert memory-formatted String back to Long Integer.
    hProcess = MemStringToLong(MidB(sPROCESS_INFORMATION, 1, 4))
    hThread = MemStringToLong(MidB(sPROCESS_INFORMATION, 5, 4))
    dwProcessId = MemStringToLong(MidB(sPROCESS_INFORMATION, 9, 4))
    dwThreadId = MemStringToLong(MidB(sPROCESS_INFORMATION, 13, 4))


End Sub

Public Function LongToMemoryString(ByVal lInputValue As Long) As String

    Dim hWorkVal As String
    Dim n As Long
    Dim I  As Long
    '
    ' Convert to HEX value.

    hWorkVal = Hex(lInputValue)

    '
    ' Check to see if it is not zero.
    If hWorkVal <> "0" Then
        '
        ' Convert to memory storage format (Little Endian).
        ' For example, 0000A411 would convert to 11A40000.
        '
        ' Place leading zeros in 8 character sequence to
        ' maintain consistent character count
        n = Len(hWorkVal)
        If n < 8 Then
            hWorkVal = String(8 - n, "0") & hWorkVal
        End If
        '
        ' Use ChrB to rebuild Bytes.
        For I = 7 To 1 Step -2
            LongToMemoryString = LongToMemoryString & _
                                 ChrB(CInt("&H" & Mid(hWorkVal, I, 2)))
        Next I

    Else
        ' Just return zeros.
        ' Use ChrB to build Bytes.
        LongToMemoryString = ChrB(CInt("&H00"))
        LongToMemoryString = LongToMemoryString & ChrB(CInt("&H00"))
        LongToMemoryString = LongToMemoryString & ChrB(CInt("&H00"))
        LongToMemoryString = LongToMemoryString & ChrB(CInt("&H00"))
    End If
End Function
Public Function PROCESS_INFORMATION(hProcess As Long, hThread As Long, _
                     dwProcessId As Long, dwThreadId As Long) As String
    '
    ' Convert inbound Long Integers to a memory storage String format.
    PROCESS_INFORMATION = LongToMemoryString(hProcess) & _
           LongToMemoryString(hThread) & _
           LongToMemoryString(dwProcessId) & _
           LongToMemoryString(dwThreadId)
End Function

